/*****************************************************************************
* University of Southern Denmark
* Embedded C Programming (ECP)
*
* MODULENAME.: state.h
*
* PROJECT....: Assignment 2
*
* DESCRIPTION: LightSwitching.
*
* Change Log:
******************************************************************************
* Date    Id    Change
* YYMMDD
* --------------------
* 140219  MNKR   Module created.
*
*****************************************************************************/


/***************************** Include files ******************************/
#include "lm3s6965.h"
/*****************************    Defines    *******************************/
#define  ON   1
#define  OFF  0
#define  RED  0b01000000
#define  GREEN 0b00000010
#define  YELLOW	0b00000001
/*****************************   Constants   *******************************/



/*****************************   Functions   *******************************/
void yellowLed(int a);
void greenLed(int a);
void redLed(int a);
/****************************** End Of Module *******************************/
